/*
                     __flea.pov__ 
                (written for POV v3.x)

flea, Copyright (c) 2001 Phlip
Permission is granted for use, copying, modification, distribution,
and distribution of modified versions of this work as long as the
above copyright notice is included, and the source is freely published.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
See the provided LICENSE file.

*/


# include "colors.inc"
# include "glass.inc"
# include "textures.inc"
# include "stones1.inc"
# include "stones2.inc"
# include "shapes.inc"
# include "woods.inc"
# include "metals.inc"  //  XXX do any of these include each other?
# include "golds.inc"

#declare farOut = 10;

#declare cloudDeck = on;   
#declare groundFog = on;
#declare ground = on;
 
     
     // far out
camera {
  ultra_wide_angle
  location  < 350*farOut, 2400, -350*farOut>
  look_at   < 0, 2200, 0>
//  location  < 350*farOut, 200, -350*farOut>
  //look_at   < 0, 500, 0>
  right x*image_width/image_height  // aspect
 angle 60                         // field
 // angle 8                         // field
}  
     
#include "fleaPrefix.inc"     
 
   /*  // above
camera {
  ultra_wide_angle
//  location  < 50*farOut, 12000, -50*farOut>
  location  < 0, 12000, 0>
  look_at   < 0, 4000, 0>
  right x*image_width/image_height  // aspect
  angle 120                          // field
}    */
 
      /*// inside
camera {
  ultra_wide_angle
  location  < 400, 2600, 500>
  look_at   < 0, 2300, 0>
  right x*image_width/image_height  // aspect
  angle 180                          // field
}     */

/*
      // closeup
camera {
  ultra_wide_angle
  location  < 700, 1700, 700>
  look_at   < 0, 1600, 0>
  right x*image_width/image_height  // aspect
  angle 75                          // field
} */
   
#if (cloudDeck=on)
   
   // ***************************************************************
// a lighter version of Darin Dugger's T_Clouds from "skies.inc"
// modified by Friedrich A. Lohmueller for using with "fog": 
// ***************************************************************
#declare T_Cloud2_Lo =
texture {
    pigment { bozo
        turbulence 1.5
        octaves 10
        omega 0.5
        lambda 2.5
        color_map { [0.0 color rgbf<0.85, 0.85, 0.85, 0.00>*1.3 ]
                    [0.5 color rgbf<0.95, 0.95, 0.95, 0.90>*1.1 ]
                    [0.7 color rgbf<1, 1, 1, 1> ]
                    [1.0 color rgbf<1, 1, 1, 1> ] }
    }

    finish {ambient 0.95 diffuse 0.1}
}
//--------------------------- 
#declare T_Cloud3_Lo =
texture {
    pigment { bozo
        turbulence 0.8 //0.6
        octaves 10
        omega 0.5
        lambda 2.5
        color_map { [0.0 color rgbf<0.95, 0.95, 0.95, 0.00>]
                    [0.4 color rgbf<0.90, 0.90, 0.90, 0.90>]
                    [0.7 color rgbf<1, 1, 1, 1> ]
                    [1.0 color rgbf<1, 1, 1, 1> ] }
           }
    finish {ambient 1.0 diffuse 0.0 }
    scale 10
}
texture {
    pigment { bozo
        turbulence 0.8 //0.6
        octaves 10
        omega 0.5
        lambda 2.5
        color_map { [0.00, color rgbf<.85, .85, .85, 0.5>*1.2 ]
                    [0.35 color rgbf<.95, .95, .95, .95>]
                    [0.5 color rgbf<1, 1, 1, 1> ]
                    [1.0 color rgbf<1, 1, 1, 1> ] }
    }
    finish { ambient 0.95 diffuse 0.0}
scale 20
translate y*-0.15
}


// Darin Dugger's DD_Cloud_Sky texture mapped onto a pair of planes
//  first cloud level  500
// second cloud level 3000 

// "hollow" added by Friedrich A.Lohmueller,2000
// for using together with fog!


#declare O_Cloud2_Lo =
union {
 plane { <0,1,0>, 500 hollow //!!!!
        texture { T_Cloud3_Lo  scale 500}}
    
 plane { <0,1,0>, 3600 hollow //!!!!
        texture { T_Cloud3_Lo  scale 1200}}
    
 plane { <0,1,0>, 8000 hollow //!!!!
        texture { T_Cloud3_Lo scale <900,1,3000>}}
    
 plane { <0,1,0>, 3000 hollow  //!!!!
        texture {T_Cloud2_Lo scale <900,1,3000> 
                 translate <3000,0,0> rotate <0,-30,0>}}

/* plane { <0,1,0> , 10000  hollow
        texture{ pigment {color SkyBlue*0.95}
                 finish {ambient 1 diffuse 0}}}*/
scale<1.5,1,1.25>
}//------------------------------------------------



object{O_Cloud2_Lo rotate<0,0,0> translate<0,1000,500>}
         
         
         
#end
  
  /*
//------------------------------------------------
// fog at the horizon
fog{fog_type   2
    distance   1000
    color red 0.09 green 0.02 blue 0.18
    fog_offset 0.1
    fog_alt    5
    turbulence 0.8}
//------------------------------------------------
*/
           
#if (groundFog = on)

/*fog{
    color red 0.09 green 0.02 blue 0.18
    fog_type 1
    fog_alt 0.35
    fog_offset 0
    distance 7500 // 0
//    turbulence <.15, .15, .15>
    omega 0.35
    lambda 1.25
    octaves 5
}     */

//------------------------------------------------
// fog at the horizon
fog{fog_type   1
    distance   100000
    color      SkyBlue
    fog_offset 0.1
    fog_alt    5
    turbulence 0.8}
//------------------------------------------------
  

//------------------------------------------------
// haze
fog{fog_type   2
    distance   10000
    color      SkyBlue*0.8
    fog_offset 300
    fog_alt    300
    turbulence 0.8}
//------------------------------------------------


  
  /*
//------------------------------------------------
// haze
fog{fog_type   2
    distance   10000
    color Yellow*0.75
    fog_offset 300
    fog_alt    300
    turbulence 0.8}
//------------------------------------------------

*/
#end
   
   

background { color Gray80 }
   
#if (ground=on)   
   plane
{ <0,1,0>,-1000
                                            
  pigment { checker Brown, Green scale 650*2 }
}         
#end
  

#declare col_0  = color red 1.0 green 1.0 blue 1.0;
#declare col_1  = color red 0.8 green 0.498039 blue 0.196078;
#declare col_2  = color red 1.0;
#declare col_3  = color red 1.0 green 1.0;
#declare col_4  = color green 1.0;
#declare col_5  = color blue 0.3 green 0.8;
#declare col_6  = color blue 1.0;
#declare col_7  = color red 1.0 blue 1.0;
#declare col_8  = color red 0.439216 green 0.858824 blue 0.576471;
#declare col_9  = color red 1.0 green 0.498039 blue 0.0;
#declare col_10 = color red 0.258824 green 0.258824 blue 0.435294;
#declare col_11 = color red 0.6 green 0.196078 blue 0.8;
#declare col_12 = color red 0.439216 green 0.576471 blue 0.858824;
#declare col_13 = color red 0.556863 green 0.137255 blue 0.137255;
#declare col_14 = color red 0.858824 green 0.858824 blue 0.439216;
#declare col_15 = color red 0.623529 green 0.623529 blue 0.372549;


#declare Candle =
union{
lathe{
linear_spline 27,
<0.0000000000,0.0000000000>,
<7.240741E-02,3.003827E-02>,
<8.423334E-02,0.0392000000>,
<9.441235E-02,5.047037E-02>,
<0.1028877000,6.362963E-02>,
<0.1096667000,0.0783000000>,
<0.1147864000,9.422963E-02>,
<0.1184025000,0.1116704000>,
<0.1207000000,0.1310000000>,
<0.1218333000,0.1525333000>,
<0.1218333000,0.1763333000>,
<0.1207000000,0.2024000000>,
<0.1182444000,0.2312370000>,
<0.1135222000,0.2653630000>,
<0.1054000000,0.3078000000>,
<9.324814E-02,0.3600605000>,
<7.845185E-02 0.4176173000>,
<0.0629000000,0.4744333000>,
<4.822963E-02,0.5254210000>,
<3.507037E-02,0.5692901000>,
<0.0238000000,0.6057000000>,
<1.473333E-02,0.6344136000>,
<7.933334E-03,0.6556087000>,
<0.0034000000,0.6695666000>,
<1.007407E-03,0.6769086000>,
<1.259259E-04,0.6796135000>,
<0.0000000000,0.6799999000>
 texture{
  pigment{rgbt 1
 }
}
 interior{
 media{
 emission 1 
 scattering{1,.01}
 intervals 10 
 samples 1, 15
 confidence 0.9999 
 variance 1/1000 
 density {
 radial 
 turbulence .35
 color_map{
 [ 0 rgb<1.0,1.0,0.0>]
 [.1 rgb<1.0,.50,0.0>]
 [.5 rgb<1.0,.75,.25>]
 [.7 rgb<0.7,.45,0.0>]
 [ 1 rgb<1.0,.65,0.0>]
   }
  }
 }
}
 hollow 
  scale<1.25,2,1.25>*3 
   translate y*1.25
}

intersection{
cone{y*-8,.75,y*1,.5 
 pigment{rgb<1,1,.97>}
  finish{ambient .5 diffuse .23}
}
sphere{<.05,1,0>,.5 inverse
 pigment{rgb 1}
  finish{ambient .5 diffuse .23}
 }
}

cylinder{y*.8,y*1.5,.1 
 pigment{rgb 0}
 }
}
   


# include "flea.inc"

object {Lsystem
	rotate <0, 120, 0>
	}
           


object {light_source { <60000 , 50000, 0> color White * 4}}
object {light_source { <66000, 3000, 0> color Gray60 * 2}}      
object {light_source { <66000, 300, 0> color Gray60}}      

object {light_source { <66000, 2500, -5000> color Gray60}}      
  

/*
object {light_source { <10000 , 6000, 1000> color White}}
object {light_source { < 0, 6600, 100> color Gray60}}
object {light_source { <10000 , 6000, 500> color White}}
object {light_source { < 0, 6600, 1500> color Gray60}}
*/

